package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingEspecificoCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_PricingEspecificoCategoria;

@Repository("gp_pricingEspecificoCategoriaDAO")
public class GP_PricingEspecificoCategoriaHibernateDAO extends GenericHibernateDAO<GP_PricingEspecificoCategoria, Long> implements GP_PricingEspecificoCategoriaDAO {

	@Autowired
	public GP_PricingEspecificoCategoriaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<GP_PricingEspecificoCategoria> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public Boolean isDuplicado(GP_PricingEspecificoCategoria entidad) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("categoria.categoriaId", entidad.getCategoria().getCategoriaId()));

		return c.list().isEmpty();
	}
}
